# Module: sysSettings
#
# Description: This script is used to list the system settings of the EVM
# 
# Copyright (C) 2010 Texas Instruments Incorporated - http://www.ti.com/
#
#  Redistribution and use in source and binary forms, with or withou
#  modification, are permitted provided that the following conditions
#  are met:
#
#  Redistributions of source code must retain the above copyright
#  notice, this list of conditions and the following disclaimer.
#  
#  Redistributions in binary form must reproduce the above copyright
#  notice, this list of conditions and the following disclaimer in the
#  documentation and/or other materials provided with the
#  distribution.
#
#  Neither the name of Texas Instruments Incorporated nor the names of
#  its contributors may be used to endorse or promote products derived
#  from this software without specific prior written permission.
#
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

echo "-------------------------------------------------------------"
echo "About This EVM"
echo "-------------------------------------------------------------"
echo ""
cat /proc/cpuinfo
cat /proc/version | awk '{gsub("version","version\t:");print}' | awk '{gsub(" \\(","\n");print}' | awk '{gsub("gcc","GCC");print}' | awk '{gsub(" \\) ","\n");print}'  | awk '{gsub("\\)","");print}' 
#sgxVer=`(./bin/mem_util 0x48004B48 w 0x2 | ./bin/mem_util 0x48004B10 w 0x1 | ./bin/mem_util 0x48004B00 w 0x2 | ./bin/mem_util 0x50000014 w)`
sgxVer=`(mem_util 0x48004B48 w 0x2 )`
sgxVer=`(mem_util 0x48004B10 w 0x1)`
sgxVer=`(mem_util 0x48004B00 w 0x2)`
sgxVer=`(mem_util 0x50000014 w)`

ver5=10205
ver3=10201
ver2=10003

if [ "$sgxVer" = "$ver5" ]; then
        echo "SGX Core Version: 5.x"
elif [ "$sgxVer" = "$ver3" ]; then
        echo "SGX Core Version: 3.x"
elif [ "$sgxVer" = "$ver2" ]; then
        echo "SGX Core Version: 2.x"
else
        echo "SGX Core Version: Unknown"
fi                                 
